CSL 5.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes
CommunicatingSocket Class Reference

`#include <PracticalSocket.h>`

Inheritance diagram for CommunicatingSocket:

List of all members.

## Public Member Functions
void | connect (const string &foreignAddress, unsigned short foreignPort) throw (SocketException)
void | send (const void *buffer, int bufferLen) throw (SocketException)
int | recv (void *buffer, int bufferLen) throw (SocketException)
string | getForeignAddress () throw (SocketException)
unsigned short | getForeignPort () throw (SocketException)
string | getLocalAddress () throw (SocketException)
unsigned short | getLocalPort () throw (SocketException)
void | setLocalPort (unsigned short localPort) throw (SocketException)
void | setLocalAddressAndPort (const string &localAddress, unsigned short localPort=0) throw (SocketException)

## Static Public Member Functions
static void | cleanUp () throw (SocketException)
static unsigned short | resolveService (const string &service, const string &protocol="tcp")

## Protected Member Functions
| CommunicatingSocket (int type, int protocol) throw (SocketException)
| CommunicatingSocket (int newConnSD)

## Protected Attributes
int | sockDesc

## Detailed Description

Socket which is able to connect, send, and receive

Definition at line 134 of file PracticalSocket.h.

## Constructor & Destructor Documentation

CommunicatingSocket::CommunicatingSocket | ( | int | type,
|  | int | protocol
| ) |  | throw (SocketException)
| protected

Definition at line 179 of file PracticalSocket.cpp.

CommunicatingSocket::CommunicatingSocket | ( | int | newConnSD | ) |
| protected

Definition at line 183 of file PracticalSocket.cpp.

## Member Function Documentation

void CommunicatingSocket::connect | ( | const string & | foreignAddress,
|  | unsigned short | foreignPort
| ) |  | throw (SocketException)

Attempt to establish a socket connection with the given foreign address and port

Parameters:

  foreignAddress | foreign address (IP address or name)
  foreignPort | foreign port

Returns:
  true if connection successfully established

Exceptions:

  SocketException | thrown if unable to establish connection

Definition at line 186 of file PracticalSocket.cpp.

References fillAddr().

Referenced by UDPSocket::disconnect().

void CommunicatingSocket::send | ( | const void * | buffer,
|  | int | bufferLen
| ) |  | throw (SocketException)

Write the given buffer to this socket. Call connect() before calling send()

Parameters:

  buffer | buffer to be written
  bufferLen | number of bytes from buffer to be written

Returns:
  true if the send is successful

Exceptions:

  SocketException | thrown if unable to send data

Definition at line 198 of file PracticalSocket.cpp.

int CommunicatingSocket::recv | ( | void * | buffer,
|  | int | bufferLen
| ) |  | throw (SocketException)

Read into the given buffer up to bufferLen bytes data from this socket. Call connect() before calling recv()

Parameters:

  buffer | buffer to receive the data
  bufferLen | maximum number of bytes to read into buffer

Returns:
  number of bytes read, 0 for EOF, and -1 for error

Exceptions:

  SocketException | thrown if unable to receive data

Definition at line 205 of file PracticalSocket.cpp.

string CommunicatingSocket::getForeignAddress | ( |  | ) | throw (SocketException)

Get the foreign address. Call connect() before calling recv()

Returns:
  foreign address

Exceptions:

  SocketException | thrown if unable to fetch foreign address

Definition at line 215 of file PracticalSocket.cpp.

References Socket::sockDesc.

unsigned short CommunicatingSocket::getForeignPort | ( |  | ) | throw (SocketException)

Get the foreign port. Call connect() before calling recv()

Returns:
  foreign port

Exceptions:

  SocketException | thrown if unable to fetch foreign port

Definition at line 226 of file PracticalSocket.cpp.

References Socket::sockDesc.

string Socket::getLocalAddress | ( |  | ) | throw (SocketException)
| inherited

Get the local address

Returns:
  local address of socket

Exceptions:

  SocketException | thrown if fetch fails

Definition at line 115 of file PracticalSocket.cpp.

unsigned short Socket::getLocalPort | ( |  | ) | throw (SocketException)
| inherited

Get the local port

Returns:
  local port of socket

Exceptions:

  SocketException | thrown if fetch fails

Definition at line 125 of file PracticalSocket.cpp.

void Socket::setLocalPort | ( | unsigned short | localPort | ) | throw (SocketException)
| inherited

Set the local port to the specified port and the local address to any interface

Parameters:

  localPort | local port

Exceptions:

  SocketException | thrown if setting local port fails

Definition at line 135 of file PracticalSocket.cpp.

void Socket::setLocalAddressAndPort | ( | const string & | localAddress,
|  | unsigned short | localPort = `0`
| ) |  | throw (SocketException)
| inherited

Set the local port to the specified port and the local address to the specified address. If you omit the port, a random port will be selected.

Parameters:

  localAddress | local address
  localPort | local port

Exceptions:

  SocketException | thrown if setting local port or address fails

Definition at line 148 of file PracticalSocket.cpp.

References fillAddr().

void Socket::cleanUp | ( |  | ) | throw (SocketException)
| static inherited

If WinSock, unload the WinSock DLLs; otherwise do nothing. We ignore this in our sample client code but include it in the library for completeness. If you are running on Windows and you are concerned about DLL resource consumption, call this after you are done with all Socket instances. If you execute this on Windows while some instance of Socket exists, you are toast. For portability of client code, this is an empty function on non-Windows platforms so you can always include it.

Parameters:

  buffer | buffer to receive the data
  bufferLen | maximum number of bytes to read into buffer

Returns:
  number of bytes read, 0 for EOF, and -1 for error

Exceptions:

  SocketException | thrown WinSock clean up fails

Definition at line 159 of file PracticalSocket.cpp.

unsigned short Socket::resolveService | ( | const string & | service,
|  | const string & | protocol = `"tcp"`
| ) |  |
| static inherited

Resolve the specified service for the specified protocol to the corresponding port number in host byte order

Parameters:

  service | service to resolve (e.g., "http")
  protocol | protocol of service to resolve. Default is "tcp".

Definition at line 167 of file PracticalSocket.cpp.

## Member Data Documentation

int Socket::sockDesc
| protected inherited

Definition at line 126 of file PracticalSocket.h.

Referenced by TCPServerSocket::accept(), UDPSocket::disconnect(), getForeignAddress(), getForeignPort(), UDPSocket::joinGroup(), UDPSocket::leaveGroup(), UDPSocket::recvFrom(), UDPSocket::sendTo(), UDPSocket::setBroadcast(), and UDPSocket::setMulticastTTL().

The documentation for this class was generated from the following files:

- CSL/Spatializers/VBAP/PracticalSocket.h
- CSL/Spatializers/VBAP/PracticalSocket.cpp